<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: archive
 *
 * Description:
 *   WEB interface for listing content of a DICOM DIR database.
 * also imports studies from DICOM DIR content.
 *
 * Parameters:
 *
 *  @param cOper      get: import studies from DICOM DIR
 *  @param cStudyUID  list of Study Instance UID of the studies to be imported
 *
 *  General table parameters: filters, fields, pagesize, ...
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@page import="imagemed.util.Helper"%>
<%@page import="imagemed.util.LocalizedMessage"%>
<%@page import="imagemed.http.IMRequest"%>
<%@
	page import="java.util.*, java.sql.*, java.io.*, java.text.Format, 
			imagemed.imsession.*, imagemed.jsputil.*, 
			com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
			imagemed.types.flag.IMTypeur, imagemed.dotcom.*, imagemed.exception.*, java.nio.file.*"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%

	IMSession is = new IMSession( request, response, out );

	String parIface = request.getParameter( "cIface" );
	String tab = "archive/dicomdir.jsp";
	boolean isIface = false;
	if ( "tabs".equals( parIface ) ) {
		// show tabs for page called via HTTP API
		isIface = true;
	}
	else if ( "true".equals( parIface ) ) {
		// hide tabs for page called via HTTP API
		isIface = true;
		tab = null;		
	}
	
	// cBack is only used when called from HTTP API 
	String parBack = request.getParameter( "cBack" );
	
	IMRequest reqPar = new IMRequest( request );
	String parOper = reqPar.getVal( "cOper" );

	is.bRegNotNeeded = ( parOper != null );
	if ( !is.regOK() ) {
		return;
	}

	if ( !is.bRegNotNeeded && is.regID == null )
		return;

	if ( !is.hasRight( IMTypeur.IMPORT_CD ) ) {
		String errorTitle = LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" );
		throw new IMCommonGUIException( is, LocalizedMessage.getSimpleMessage( "NO_RIGHTS_REQ_PAGE" ), tab, errorTitle, parBack, 0 );
	}
	reqPar = is.imRequest;
	reqPar.delProperty( "cOper" );
	String parMedia = reqPar.getVal( "cMedia" );
	if ( parMedia == null ) {
		parMedia = "";
	}

	boolean isFilesOnly = "true".equals( reqPar.getVal( "cFilesOnly" ) );

	Helper.DEBUG( "dicomdir.jsp", "parMedia:" + parMedia );

	if ( parMedia.length() == 0 ) {
		String cdPath = DicomDirToolbox.getLocalShares().getProperty( "CD" );
		if ( cdPath != null && cdPath.length() > 0 ) {
			try (DirectoryStream<Path> ds = Helper.getDirectoryStream( cdPath )) {
				if ( ds != null ) {
					for ( Path path : ds ) {
						if( path == null ){
							continue;
						}
						parMedia = "CD";
						reqPar.setProperty( "cMedia", "CD" );
						break;
					}
				}
			}
			catch ( IOException e ) {
				//if automatic close was not successful
			}
		}
	}
	String mountedMedia = DicomDirToolbox.getMountPoint( is, parMedia );

	String parSubDir = reqPar.getVal( "cSubDir" );
	if ( parSubDir == null ) {
		parSubDir = "";
	}

	Helper.DEBUG( "dicomdir.jsp", "parSubdir:" + parSubDir );

	String parMediaDir = mountedMedia + parSubDir;

	String context = reqPar.m_context;
	if ( context == null || context.length() == 0 ) {
		context = reqPar.backupContext();
	}
	else {
		reqPar.passAsFile( context );
	}

	String parMode = reqPar.getVal( "cMode" );
	if ( parMode == null || "".equals( parMode ) ) {
		parMode = "Server";
	}

	String parTargetHUB = reqPar.getVal( "cTargetHUB" );
	if ( parTargetHUB == null ) {
		parTargetHUB = "";
	}

	// directory of temporary dicomdir
	String tempDirName = null;

	// filename of temporary dicomdir
	String tempFilename = null;

	String outputFileName = null;

	String dicomDir = "";

	//if no dicomdir exists, cTempName will include the parent directory only, with /
	String parTempName = reqPar.getVal( "cTempName" );
	if ( parTempName == null ) {
		parTempName = "";
	}
	else {
		int namepos = parTempName.lastIndexOf( '/' );
		if ( namepos != -1 ) {
			tempDirName = parTempName.substring( 0, namepos );
			outputFileName = tempDirName + "/createdicomdiroutput";
			tempFilename = parTempName.substring( namepos + 1 );
			if ( tempFilename != null && !"".equals( tempFilename ) ) {
				dicomDir = parTempName;
			}
		}
	}

	String parStudyDir = reqPar.getVal( "cStudydir" );
	if ( parStudyDir == null ) {
		parStudyDir = "";
	}

	if ( parMedia.length() > 0 && "yes".equals( reqPar.getVal( "cDoCheckShare" ) ) && !DicomDirToolbox.isShareLocal( parMedia ) ) {
		reqPar.delProperty( "cDoCheckShare" );
		reqPar.passAsFile( context );
%>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_HTMLPAGE_TITLE" ) %></TITLE>
<%
		imagemed.http.tabs.TabBean.writeStyleOnly( is );
%>
</head>

<BODY>
<%
		if ( tab != null ) {
			TabToolbox.makeTabs( is, is.tabbean, tab, "White" );
		}
%>
<H2><%= LocalizedMessage.getCompoundMessage( "ARCHIVE_DICOMDIR_CONNECTING_TO_SHARE", new Format[] { null }, new Object[] { parMedia }, false ) %>.</H2>
<%
		out.flush();
		String error = DicomDirToolbox.addMountPoint( is, parMedia );
		if ( error != null ) {
			out.println( "<font color=red><h3>" + error + "</h3></font>" );
			out.flush();
			parMedia = "";
			Thread.sleep( 5000 );
		}
%>
<form name="redirectForm" method=get>
<input type=hidden name="cMedia" value="<%=parMedia%>">
<input type=hidden name="cContext" value="<%=context%>">
<%
		if ( isIface ) {
%>
<input type=hidden name="cIface" value="<%= parIface %>">
<%
		}
		if ( parBack != null ) {
%>
<input type=hidden name="cBack" value="<%= Helper.htmlEncode( parBack ) %>">
<%
		}
%>
</form>
<script language="JavaScript">
	self.document.redirectForm.submit();
</script>
<%
	return;
	} // cDoCheckShare
	else if ( "yes".equals( reqPar.getVal( "cDoCheckShare" ) ) ) {
		reqPar.delProperty( "cDoCheckShare" );
		reqPar.passAsFile( context );
	}

	if ( "Server".equals( parMode ) ) {
		if ( parMedia.length() > 0 ) {
	String[] files = Helper.getDirectoryContentAsStringArray( parMediaDir, "[Dd][Ii][Cc][Oo][Mm][Dd][Ii][Rr]" );
	if ( files != null ) {
		for(String file : files){
	dicomDir = parMediaDir + "/" + file;
		}
	}
		}
	}
	/* Input Parameters	*/

	String[] parStudyUIDs = reqPar.getVals( "cGr" ); // StudyUID");

	if ( null == parOper ) {
		parOper = "";
	}


	// --- Init Table without Result ---

	String thisPage = "/archive/dicomdir.jsp";
	String thisPageMenuTab = tab == null ? null : tab + "?cMode=Client";

	TableDescriptorImpl tdesc = new TableDescriptorImpl( thisPage, false, true, true, false );
	TablePropertiesImpl tprop = new TablePropertiesImpl();

	String[] defaultFields = TableParamsImpl.getDefaultFields( thisPage, is );
	IMFieldManagerImpl fm = new IMFieldManagerImpl( IMEnvBase.getEnv( "FIELDSTBL" ), IMEnvBase.getEnv( "TYPESTBL" ) );

	TableParamsImpl tparams = new TableParamsImpl( is.imRequest );
	tparams.setDefaultFields( defaultFields );
	tparams.setDefaultPage( 1 );
	tparams.setDefaultPageSize( 20 );
	String extraParams[] = {};
	tparams.setExtraParams( extraParams );

	tdesc.setFieldManager( fm );
	tdesc.setTableParams( tparams );
	tdesc.setTableProperties( tprop );

	String uglyAddendum = " method=post>\n";
	uglyAddendum += "<input type=hidden name=\"cContext\" value=\"" + context + "\">";//reqPar.passAsFormAll();
	uglyAddendum += "<input type=hidden name=\"cOper\" value=\"unset\"";

	tdesc.setFormParams( tdesc.getFormParams() + uglyAddendum);

	ActionImpl acts[] = new ActionImpl[ 1 ];
	acts[ 0 ] = new ComboAction( tdesc, ComboAction.TYPE_MEDIA, "r" );

	ActionImpl act[] = new ActionImpl[ 2 ];
	act[ 0 ] = new CheckboxAction( tprop, "SYUI", "cGr", null );
	act[ 1 ] = new MultiAction( tprop, acts );


	ActionImpl batchAct[] = new ActionImpl[ 1 ];
	batchAct[ 0 ] = new LinkAction( tdesc, null, "JavaScript:Batch_(\"get\")", "<IMG SRC=\"/cases/art/get.gif\" width=\"16\" height=\"20\"" + " alt=\"" + LocalizedMessage.getSimpleMessage( "ALT_TEXT_GET_SELECTED_STUDIES" ) + "\" border=0>",
	LocalizedMessage.getSimpleMessage( "ALT_TEXT_GET_SELECTED_STUDIES" ) );

	ColumnImpl col = new ColumnImpl( new BatchHeader( batchAct ), new ActionCell( "SYUI", act ), "SYUI" );
	tdesc.addExtraColumn( "_FIRST", col );

	Properties TDsettingsPage = new Properties();
	TDsettingsPage.setProperty( "align", "right" );

	List<TopCellImpl> topCell = new ArrayList<TopCellImpl>();
	topCell.add( new TitleTopCell( tprop, LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_CONTENT_MEDIA" ) ) );

	//for CWL servers there is no Server mode
	DotcomDevice selfDevice = DotcomConfig.selfDevice();
	if ( selfDevice != null && !selfDevice.isDbOnly() ) {
		StringBuilder params = new StringBuilder( 256 );
		if ( isIface ) {
	params.append( "&cIface=" ).append( parIface );
		}
		if ( parBack != null ) {
	params.append( "&cBack=" ).append( Helper.URLEncodeUTF8( parBack ) );
		}
		topCell.add( new SimpleTopCell( tprop, DicomDirToolbox.getModeSelect( is, parMode, params.toString() ) ) );
	}

	topCell.add( new SeparatorTopCell( tprop, 16 ) );

	if ( "Server".equals( parMode ) ) {
		topCell.add( new DicomDirTopCell( tdesc, is ) );
	}
	else {
		StringBuilder params = new StringBuilder( 256 );
		params.append( "&cTargetHUB=" ).append( parTargetHUB );
		if ( isIface ) {
	params.append( "&cIface=" ).append( parIface );
		}
		if ( parBack != null ) {
	params.append( "&cBack=" ).append( Helper.URLEncodeUTF8( parBack ) );
		}
		
		topCell.add( new EmbedUploadTopCell( tprop, params.toString() ) );
	}
	//	topCell.add(new SambaSwitchTopCell(tdesc, is));
	
	if ( parBack != null ) {
		topCell.add( new SeparatorTopCell( tprop, 4 ) );
		Properties backCellPrp = new Properties();
		backCellPrp.setProperty( "align", "right" );
		backCellPrp.setProperty( "width", "100%" );
		topCell.add( new SimpleTopCell( tprop, "<a href=\"" + parBack +
	"\"><script language=\"JavaScript\">getButtonFull(\"backButton\", 24, 24, \"\");</script></a>", backCellPrp ) );
	}
	else {
		TDsettingsPage.setProperty( "width", "100%" );
	}
	
	topCell.add( new SeparatorTopCell( tprop, 4 ) );
	topCell.add( new PageTopCell( tprop, tparams, TDsettingsPage ) );

	tdesc.setTopCells( topCell.toArray( new TopCellImpl[]{} ) );

	// --- Oper ---

	//simple importing from the server:
	//server mode OR client mode + files + we are not dbonly
	if ( parStudyUIDs != null && parStudyUIDs.length != 0 ) {
		if ( "get".equals( parOper ) &&
		( "Server".equals( parMode ) ||
		( "Client".equals( parMode ) && isFilesOnly && !selfDevice.isDbOnly() ) ) ) {
	// select studies that can be retrieved
	String dir = parMediaDir;
	if ( !"Server".equals( parMode ) ) {
		if ( tempDirName != null ) {
	dir = tempDirName;
		}
		else {
	throw new RuntimeException( LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_TEMPNAME_ILLEGAL" ) + ":" + parTempName );
		}
	}

	Helper.DEBUG( "importing, dir name:" + dir );

	DicomDirToolbox.startImporting( is, parStudyUIDs, dir, false );
	DicomDirToolbox.doRedirection( is, parStudyUIDs.length > 1 ? LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_IMPORTING_STUDY_PLURAL" ) : LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_IMPORTING_STUDY" ) + ".", 3000 );

	return;
		}
	}

	// --- Init Table with Result ---

	DicomDirResult DDR = new DicomDirResult( tdesc, dicomDir );
	tdesc.setResult( DDR );

	TableImpl table = new TableImpl( tdesc );
%><%-- --- HTML --- -- %>
<HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_HTMLPAGE_TITLE_MEDIA" ) %></TITLE>
<SCRIPT Language="JavaScript">
 	var pageContext="<%=context%>";
 </script>
<%
	TabToolbox.writeIMpopup(is.out);
	table.printScript(tparams, is);
%>
<SCRIPT language="JavaScript">
	function Batch_(oper) {
		self.document.Batch.cOper.value=oper;
		self.document.Batch.submit();
	}
</SCRIPT>
</head>

<BODY>

<form name=getForm method=post action="/archive/dicomdir.jsp"><%--=reqPar.passAsFormAll()-- %>
<input type=hidden name="cContext" value="<%=context%>"> 
<input type=hidden name="cOper" value="get"> 
<input type=hidden name="cGr" value="">
<input type=hidden name="cMode" value="<%=parMode%>"> 
<%
		if ( isIface ) {
%>
<input type=hidden name="cIface" value="<%= parIface %>">
<%
		}
		if ( parBack != null ) {
%>
<input type=hidden name="cBack" value="<%= Helper.htmlEncode( parBack ) %>">
<%
		}
%>
</form>

<%
	if ( thisPageMenuTab != null ) {
		TabToolbox.makeTabs( is, is.tabbean, thisPageMenuTab, "White" );
	}

	// uploading with applet OR server-to-server upload if client + dicomdir OR client + files + goes to targethub
	if ( "Client".equals( parMode ) && "get".equals( parOper ) && parStudyUIDs != null && parStudyUIDs.length != 0 &&
			( !isFilesOnly || selfDevice.isDbOnly() ) ) {
		//getting filenames
		String[] env = { "HOME=" + IMEnvBase.getEnv( "HOME" ) };
		int noUIDs = parStudyUIDs.length;
		String[] cmdGet = new String[ noUIDs + 3 ];
		cmdGet[ 0 ] = IMEnvBase.getEnv( "CD_HOME" ) + "/ddgetnames.sh";
		String studyUIDs = "";
		if ( tempDirName == null || tempFilename == null ) {
			throw new RuntimeException( LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_TEMPNAME_ILLEGAL" ) + ":" + parTempName );
		}
		cmdGet[ 1 ] = tempDirName;
		cmdGet[ 2 ] = tempFilename;

		for ( int i = 0; i < noUIDs; i++ ) {
			cmdGet[ i + 3 ] = parStudyUIDs[ i ];
			studyUIDs += ";" + parStudyUIDs[ i ];
		}
		if ( studyUIDs.length() > 0 ) {
			studyUIDs = studyUIDs.substring( 1 );
		}
		String commandStr = "";
		for ( int i = 0; i < cmdGet.length; i++ ) {
			commandStr += cmdGet[ i ] + " ";
		}
		Helper.DEBUG( "dicomdir.jsp", "command: " + commandStr );
		String fileNames = Helper.runCommand( cmdGet, env );
		Helper.DEBUG( "dicomdir.jsp", "filenames: " + fileNames );
		Helper.DEBUG( "dicomdir.jsp", "filenames encoded: " + Helper.URLEncodeUTF8( fileNames ) );

		//if we are dbonly, and targethub is not defined, the first one will be used
		if ( selfDevice.isDbOnly() && "".equals( parTargetHUB ) ) {
			List<String> hubs = DotcomConfig.getConfig().getHubs( selfDevice.getId() );
			if ( hubs != null && hubs.size() > 0 ) {
				Collections.sort( hubs, Helper.compareCaseInSensitive );
				parTargetHUB = hubs.get( 0 );
			}
		}

		if ( isFilesOnly && selfDevice.isDbOnly() ) {
			//server-to-server upload
			String message = parStudyUIDs.length > 1 ? LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_IMPORTING_STUDY_PLURAL" ) : LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_IMPORTING_STUDY" ) + ".";
			if ( !DicomDirToolbox.compressAndUploadStudy( tempDirName, fileNames, parTargetHUB, parStudyUIDs ) ) {
				message = parStudyUIDs.length > 1 ? LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_PROBLEM_IMPORTING_STUDY_PLURAL" ) : LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_PROBLEM_IMPORTING_STUDY" ) + ".";
			}
			DicomDirToolbox.doRedirection( is, message, 3000 );
			return;
		}
		
		StringBuilder redirUrl = new StringBuilder( 256 );
		redirUrl.append( is.httpx_host ).append( "/archive/dicomdir.jsp?cMode=Client" );
		redirUrl.append( "&cTempName=" ).append( Helper.URLEncodeUTF8( parTempName ) );
		redirUrl.append( "&cStudydir=" ).append( Helper.URLEncodeUTF8( parStudyDir ) );
		if ( isIface ) {
			redirUrl.append( "&cIface=" ).append( parIface );
		}
		if ( parBack != null ) {
			redirUrl.append( "&cBack=" ).append( Helper.URLEncodeUTF8( parBack ) );
		}
%>
	<%= LocalizedMessage.getSimpleMessage( "ARCHIVE_DICOMDIR_UPLOADING_FROM_CLIENT" ) %>...<BR><BR>
	<embed
		type = "application/x-java-applet" 
		CODE = "ep.clients.StudyUploader"
		java_arguments = "-Xmx2048m"
		ARCHIVE = "<%=is.httpx_host + "/applets/epapplets.jar"%>,<%=is.httpx_host + "/applets/jai_codec.jar"%>"
		WIDTH = "200"
		HEIGHT = "50" 
		uploadurl = "<%=is.httpx_host + "/cases/uploadImportStudy.jsp"%>"
		redirecturl = "<%= redirUrl %>"
		studydir = "<%=parStudyDir%>"
		context = "<%=context%>" 
		filenames = "<%=Helper.URLEncodeUTF8( fileNames )%>"
		studyuids = "<%=Helper.URLEncodeUTF8( studyUIDs )%>"
		targethub = "<%=parTargetHUB%>"
		debug = "false"
		server = "<%=is.httpx_host%>"
		sessionid = "<%=is._sid%>">
	</embed>
	</BODY>
	</HTML>
<%
	return;
	}

	table.printTableTop( is );
	if ( "Client".equals( parMode ) ) {
		if ( !"".equals( parStudyDir ) ) {
			is.out.println( "<TABLE border=1 cellpadding=0 cellspacing=0 width=\"100%\"><TR class=BgShadow><TD>" );
			is.out.println( "<b><BR>&nbsp;" + parStudyDir + "<BR><BR></b>" );
			is.out.println( "</TD>" );

			if ( selfDevice.isDbOnly() ) {
				is.out.println( "<TD>" );
				List<String> hubs = DotcomConfig.getConfig().getHubs( selfDevice.getId() );
				if ( hubs != null && hubs.size() > 0 ) {
					Collections.sort( hubs, Helper.compareCaseInSensitive );
					String currentHUB = parTargetHUB;
					if ( "".equals( currentHUB ) ) {
						currentHUB = hubs.get( 0 );
					}
					is.out.println( "&nbsp;Target HUB: " );

					String hrefPrefix = thisPage + "?cTargetHUB=";
					StringBuilder hrefSuffix = new StringBuilder( 128 );
					hrefSuffix.append( "&cMode=" ).append( parMode );
					hrefSuffix.append( "&cTempName=" ).append( parTempName );
					hrefSuffix.append( "&cStudydir=" ).append( Helper.URLEncodeUTF8( parStudyDir ) );
					if ( isIface ) {
						hrefSuffix.append( "&cIface=" ).append( parIface );
					}
					if ( parBack != null ) {
						hrefSuffix.append( "&cBack=" ).append( Helper.URLEncodeUTF8( parBack ) );
					}
					if ( isFilesOnly ) {
						hrefSuffix.append( "&cFilesOnly=true" );
					}
					
%>
<SELECT name="targethub"
	onchange='l=options[selectedIndex].value; document.location.href="<%= hrefPrefix %>"+l+"<%= hrefSuffix.toString() %>";'>
<%
					for ( int i = 0; i < hubs.size(); i++ ) {
						is.out.println( DicomSrvToolbox.getOption( hubs.get( i ), hubs.get( i ), currentHUB ) );
					}
					is.out.println( "</SELECT>" );
				}
				is.out.println( "</TD>" );
			}

			is.out.println( "</TR></TABLE>" );
		}

		if ( "Client".equals( parMode ) && isFilesOnly ) {
			// give alert if problem occured during cd/createdicomdir.sh
			if ( outputFileName != null ) {
				File outputFile = new File( outputFileName );
				if ( outputFile.exists() ) {
					String content = Helper.readTextFile( outputFileName );
					if ( content != null && !"".equals( content.trim() ) ) {
						String mess = "The following problems were found during the creation of the DICOMDIR file:";
						if( content.indexOf( "E:" ) != -1 ) {
							Helper.ERRORLOG( mess + content );
						}
						else {
							Helper.INFOLOG( mess + content );
						}
					}
					outputFile.delete();
				}
			}
		}
	}
	else {
		if ( parMedia != null && parMedia.length() > 0 ) { // browser should be implemented here...
			out.println( DicomDirToolbox.getBrowserView( is, parMedia, parSubDir ) );
		}
	}
	if ( dicomDir.length() > 0 ) {
		table.print( is );

		if ( "Client".equals( parMode ) && isFilesOnly ) {
			// initially check all studies if files were uploaded from client
			is.out.print( "<script language=\"JavaScript\">Select_(true)</script>" );
		}
	}
%>
<!--<%=Helper.request2String2(request)%>-->
</BODY>
</HTML>
--%>