<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: archive
 *
 * Description:
 *   WEB interface for modifying archive rules.
 *
 * Parameters:
 *
 *  @param cOp        Save : save changes
 *  @param cAge       Age of the patients until the studies of a patient should be kept
 *  @param cKeep      Number of years a study should be kept
 *  @param cActive    Is archiving turned on or not (off)
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="imagemed.util.*,imagemed.exception.*,imagemed.jsputil.*, imagemed.imsession.*"

%><%

	IMSession is = new IMSession(request, response, out);
	if (!is.regOK()) {
		return;
	}
	if (is.regID == null)
		return;

	//Archive licence checking

	int flags = 0xFFFFFFFF;
	try {
		flags = Integer.parseInt(is.sessionVariables.getProperty("CTFlags"));
	}
	catch (Throwable t) {
	}
	if ((flags & 4)==0 )  //Archive flag==false ?
		throw new IMGeneralException("This server is not licensed to archive data","archive/rules.jsp",null,null);

	String parOp     = request.getParameter("cOp");
	String parAge    = request.getParameter("cAge");
	String parKeep   = request.getParameter("cKeep");
	String parActive = request.getParameter("cActive");

	boolean bRight = (null != is.regRights && -1 != is.regRights.indexOf("A"));
	boolean bSave  = "Save".equals(parOp);

	//Defaults

	IMProperties prpCfg = new IMProperties();
	prpCfg.setProperty("Archive","no");
	prpCfg.setProperty("Age","18");
	prpCfg.setProperty("KeepYears","7");

	if (bSave && bRight) {
		try {
			boolean changed = false;
			// First check if parAge and parKeep are positive integers
			if ( parAge!=null && parKeep!=null ) {
				int age = Integer.parseInt(parAge);
				int keep = Integer.parseInt(parKeep);
				if (age <= 0 || keep <= 0)
					throw new Throwable();

				prpCfg.setProperty("Age",parAge);
				prpCfg.setProperty("KeepYears",parKeep);
				changed = true;
			}

			if (parActive != null) {
				prpCfg.setProperty("Archive", parActive);
				changed = true;
			}

			if (changed)
				prpCfg.recWrite(IMEnvBase.getEnv("ARCHIVE_VAR") + "/archive.cfg");

			OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.OTHER, "cfg" );
			logEntry.setField( OperLogEntry.FIELD.USER, is.regID );
			logEntry.setField( OperLogEntry.FIELD.HOST, is.regIP );
			logEntry.setField( OperLogEntry.FIELD.MESSAGE, "ArchiveRules:isActive=" + parActive + "&keep=" + parKeep + "&age=" + parAge );
			logEntry.log( "rules.jsp", 0, Syslog.LOG_INFO );

//			Syslog log = new Syslog("rules.jsp",0,IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//			log.syslog(Syslog.LOG_INFO, "INFO OTHER cfg " + is.regID + " - - - - " + is.regIP +
//					" - - - - - - ArchiveRules:isActive=" + parActive + "&keep=" + parKeep + "&age=" + parAge);
		}
		catch (Throwable th) {
			throw new IMGeneralException(
					"<CENTER>An error occured while saving rules.<BR>Make sure that the numbers in the rules are positive integers.</CENTER>",
					"archive/rules.jsp", null, null);
		}
	}

	prpCfg.recRead(IMEnvBase.getEnv("ARCHIVE_VAR") + "/archive.cfg");

	boolean bArchiver  = "yes".equals(prpCfg.getProperty("Archive"));
	String  mountPoint = prpCfg.getProperty("MountPoint", "");
	if (! mountPoint.endsWith("/") )
		mountPoint = mountPoint + "/";

%><HTML>
  <HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_RULES" ) %></TITLE>
<%
	TabToolbox.writeIMpopup(out);
	imagemed.http.tabs.TabBean.writeStyleOnly(is);
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
%>

  <SCRIPT LANGUAGE="JavaScript">

    function doSubmit(frm, mod)
    {
      frm.op.value=mod;
      frm.submit();
    }

  </SCRIPT>
  </HEAD>
  <BODY>
<%
	TabToolbox.makeTabs( is, is.tabbean, "archive/rules.jsp", "White");
%>




<center>
<table border=1 cellpadding=0 cellspacing=0 width="100%">
<tr class=BgShadow>
<td width="100%"><br><table border=0 width="100%" ><tr>
<td width="50%">&nbsp;&nbsp;<font size=4><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_RULES" ) %></font></td>

</tr></table><br></td></tr>
<tr class=BgShadow><td>
  <TABLE cellpadding=0 border=1 cellspacing=0 class=BgMedLight>
  <FORM ACTION="rules.jsp" NAME="ruleForm" METHOD=POST>
  <INPUT TYPE=HIDDEN NAME="op">
  <TR>
    <TD><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_RULES_ARCHIVING" ) %></TD>
    <TD>
<%
/*
    if (bRight)
    {
      is.out.println("<SELECT NAME='cActive' SIZE=1>");
      is.out.println("  <OPTION "+ ( bArchiver  ? "SELECTED" : "" ) +" value='yes'>On");
      is.out.println("  <OPTION "+ ( !bArchiver ? "SELECTED" : "" ) +" value='no'>Off");
      is.out.println("</SELECT>");
    }
    else
*/
	String msgOn = Character.toUpperCase(LocalizedMessage.getSimpleMessage( "termON" ).charAt(0)) + LocalizedMessage.getSimpleMessage( "termON" ).substring(1);
    String msgOff = Character.toUpperCase(LocalizedMessage.getSimpleMessage( "termOFF" ).charAt(0)) + LocalizedMessage.getSimpleMessage( "termOFF" ).substring(1);
	//is.out.println( bArchiver ? msgOn : msgOff );
	is.out.println( bArchiver ? msgOff : msgOn );
%>
    </TD>
  </TR>
  <TR>
    <TD><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_RULES_MOUNT_POINT" ) %></TD>
    <TD><%= mountPoint %></TD>
  </TR>
  <TR>
    <TD><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_RULES_STUDIES_EXPIRE_AFTER" ) %></TD>
    <TD>
<%
	String keepYears = prpCfg.getProperty("KeepYears");
/*
      if (bRight && bArchiver)
        is.out.println( "<INPUT TYPE=TEXT NAME='cKeep' VALUE='" + keepYears + "' SIZE=3>" );
      else
*/
	is.out.println(keepYears);
%>
    <%= LocalizedMessage.getSimpleMessage( "IMAGEMED_IMFILTERDATE_YEARS" ) %></TD>
  </TR>
  <TR>
    <TD><%= LocalizedMessage.getSimpleMessage( "ARCHIVE_RULES_KEEP_STUDIES_UNTIL" ) %> </TD>
    <TD>
<%
	String age = prpCfg.getProperty("Age");
/*
      if (bRight && bArchiver)
        is.out.println( "<INPUT TYPE=TEXT NAME='cAge' VALUE='" + age + "' SIZE=3>" );
      else
*/
	is.out.println(age);
%>
    <%= LocalizedMessage.getSimpleMessage( "IMAGEMED_IMFILTERDATE_YEARS" ) %></TD>
  </TR>
  </TABLE></td></tr></table>
  <BR>
<%
	if (bRight) {
%>
<%--
    <A HREF="javascript:doSubmit(self.document.ruleForm,'Save');"
    onMouseOver="window.status='Save Archive Rules'; return true"
    ><%Button.printJsButton(is, "Save", " ALT=\\\"Save Archive Rules\\\"");%>
    </a>
-- %>
<%
	}
%>

  </FORM>

  </CENTER>
  </BODY>
</HTML>
--%>