#!/bin/sh
#
# Component: archive
#
# Description:
#  OBSOLETE [7.0]
#
#  merges a study from the archive back to the worklist.
#
# Usage:
#   merge.sh [-p] [-f] <styiuid>
#
#	-p		: the merge should be executed in high priority (manual retrieve)
#   -f    	:  force retrieving obsoleted studies/files
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

# if merge.sh is called directly:
# run as a task instead
if [ `basename $0` = "merge.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi

LOGGER="/usr/bin/logger"
TAG="archive/merge[$$]"

# is it a high priority task?
Priority="false"

if [ "$1" = "-p" ] ; then
	Priority="true"
	shift
fi

# force retrieving obsoleted studies/files
FORCE=""

if [ "$1" = "-f" ] ; then
	FORCE="-f"
	shift
fi

study=$1

# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	echo "@Archive @Archive-GET"
}

run_()
{
	if [ -z "$study" ] ; then
		$LOGGER -p $LOG_FACILITY.err -t "$TAG" "Missing argument"
		return 125
	fi

	$TASKD_HOME/runjavacmd -c "0 archive.Get $FORCE -m -s \"$study\"" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR
	
}


# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print archive.Get $FORCE -m -s \"$study\"" -p "$JAVA_SERVER_PORT"
}

#
# Print value to be displayed on the WEB GUI
#
get_display_name_()
{
	echo "Merge study from legacy EP archive to enterprise archive" 
}

#
# Print resources used by the task 
#
get_resources_()
{
	echo "System.NET.@Archive.GET"
}

#
# Print property value
#
get_property_()
{
	if [ "$PROPERTY" = "1PST" ] ; then
		echo -n "$study"
		return 0
	fi
	 
	if [ "$PROPERTY" = "1PPE" ] ; then
		echo -n "@Archive" 
		return 0
	fi

	get_def_property_
}
