<%--
 ** Component: cases
 **
 ** WEB interface for viewing/editing reports.
 **
 **  @param cGr               Study Instance UID
 **  @param cBack             URL to go back after viewing/editing reports
 **  @param cOp               Operation Mode: Edit, Approve, Save, batchApprove
 **  @param cSize             Image size for previewing key images:  None, 128x128, 256x256, 512x512
 **  @param cPrintFriendly    Print friendly page
 **  @param cDontPrint        Only takes effect in print friendly mode: don't start printing automatically
 **  @param cConfirm          Approve operation is confirmed
 **  @param cBreak            Break lock
 **  @param cTemplate					Use this template XML instead of user's or system's default
 **  @param cIntegrated				the page is used as a report edit in the viewer
 **  @param cAjaxSave					the page is used to save a report modified during batch approval
 **  @param cActingUser				The user who initiated the jsp (at print and fax)
 **
 **  @param results_sopiuid   SOP Instance UID of the results
 **  @param impression        Impression text
 ** 
 **  @param int<N>_isNew        Indicates whether a new interpretation was created
 **  @param int<N>_typeid       Interpretation typeid of the <N>. interpretation
 **  @param int<N>_sopiuid      SOP Instance UID of the <N>. interpretation
 **  @param int<N>_statid       Status ID of the <N>. interpretation
 **  @param int<N>_statid_orig  Original (previous) Status ID of the <N>. interpretation
 **  @param int<N>_author       Author of the <N>. interpretation
 **  @param int<N>_recdate_yr   Year of Recorded date of the <N>. interpretation
 **  @param int<N>_recdate_mo   Month of Recorded date of the <N>. interpretation
 **  @param int<N>_recdate_dy   Day of Recorded date of the <N>. interpretation
 **  @param int<N>_rectime_hr   Hour of Recorded time of the <N>. interpretation
 **  @param int<N>_rectime_mi   Minute of Recorded time of the <N>. interpretation
 **  @param int<N>_text         Interpretation text of the <N>. interpretation
 **  @param int<N>_birads       Birads code of the <N>. interpretation (for MG studies)
 ** 
 **  <N> is a serial number started with 0
 ** 
--%><%@page import="com.erad.pacs.common.interfaces.result.WorklistResult"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.services.usermanager.service.internal.SessionToolbox"
%><%@page import="com.erad.pacs.modules.gwt.descriptors.usermanager.SessionInfo"
%><%@page import="com.erad.pacs.services.usermanager.client.Envelope"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%@
	page import="java.io.*, java.util.*, java.sql.*,
			com.erad.pacs.app.broker.table.TableBrokerFacade,
			com.erad.pacs.app.broker.table.internals.TableDescriptorImpl,
			com.erad.pacs.app.broker.table.internals.imtables.*,
			com.erad.pacs.services.usermanager.client.Session,
			com.erad.pacs.common.libs.RequestInfo,
			com.erad.pacs.connector.Connector,
			com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade,
			com.erad.pacs.toolbox.OutsideScopeToolbox,
			imagemed.imsession.*, imagemed.exception.*, imagemed.util.*, imagemed.jsputil.*, imagemed.dotcom.DotcomConfig,
			imagemed.layout.*, imagemed.layout.datasource.*, imagemed.layout.visitors.*, imagemed.layout.macro.input.RichTextAreaInputMacro, 
			imagemed.types.*, imagemed.types.number.IMTypeATNM, imagemed.types.date.TimeStamp,
			imagemed.types.enumeration.IMTypeos, imagemed.jsputil.ReportToolbox.InterpretationInfo,
			imagemed.users.*"

%><%!

	String html2psFix(String html) {
		html = Helper.replace(html, "<BR>", "<br>");
		html = Helper.replace(html, "<bR>", "<br>");
		html = Helper.replace(html, "<Br>", "<br>");
		html = Helper.replace(html, "<BR/>", "<br>");
		html = Helper.replace(html, "<bR/>", "<br>");
		html = Helper.replace(html, "<Br/>", "<br>");
		html = Helper.replace(html, "<br/>", "<br>");
		html = Helper.replace(html, "<br>", "&nbsp;<br>");
		html = Helper.replace(html, "&nbsp;&nbsp;<br>", "&nbsp;<br>");
//		html = Helper.replace(html, "<br//>", "<br>"); // the dirtiest hack ever.
//		html = Helper.replace(html, "&nbsp;<br>", "<u style=\"\">&nbsp;<br></span>");
//		html = Helper.replace(html, "<br>", "<img src=\"/cases/art/spacer.gif\" width=1 height=1><br>");
		return html;
	}

/*
	public static WorklistResult staticGetWLR( Session sess, String study ) {
		TableDescriptorImpl tdesc = new TableDescriptorImpl();
		WorklistTableParamsImpl tparams = new WorklistTableParamsImpl( sess.getProfileUser().getUserId(  ) );
		tparams.setDefaultFields( EditToolbox.allDbColids.toArray( new String[]{} ) );
	
		if ( study != null ) {
			Properties filters = new Properties();
			filters.setProperty( "SYUI", study );
			tparams.setDefaultFilters( filters );
		}
	
		tdesc.setTableParams( tparams );
	
		WorklistResult result = new WorklistResultImpl( sess, tdesc );
		result.setGlobal( true );
		return result;
	}
*/

	String tryToGetParamAndStore( String param, Properties sessionVariables, HttpServletRequest request ) {
		String fromSession = sessionVariables.getProperty( param );
		if (fromSession == null) {
			String fromRequest = request.getParameter( param );
			if (fromRequest != null) {
				sessionVariables.put( param, fromRequest );
				return fromRequest;
			}
		} else {
			return fromSession;
		}
		return null;
	}

%><%
	Session sess;
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	// check and allow localhost calls
	
	try {
		sess = userManager.getSessitaSession( request, response );
	} 
	catch ( SessionException se ) {
		if ( SessionToolbox.checkServerIp( request.getRemoteAddr() ) ) {
			String user = request.getParameter( "cActingUser" );
			if ( user == null ) {
				user = SessionInfo.SYSTEM_USERID;
			}
			Envelope userEnvelope = userManager.loginService( user );
			sess = userManager.checkEnvelope( request, response, userEnvelope );
		}
		else {
			throw se;
		}
	}
	

	RequestInfo requestInfo = new RequestInfo(request);
	
	HtmlVisitorViewContext vc = new HtmlVisitorViewContext( request, sess, request.getParameter( "cContext" ), false );	

	response.setHeader("Cache-Control","no-cache"); //HTTP 1.1
	response.setHeader("Pragma","no-cache"); //HTTP 1.0
	response.setDateHeader ("Expires", -1); //prevents caching at the proxy server

/*	if (!sess.regOK(!"batchApprove".equals(request.getParameter("cOp")))) {
		return;
	}*/
	

	String parStudy     = tryToGetParamAndStore( "cGr", vc.getSessionVariables(), request );
	String parActingUser = tryToGetParamAndStore( "cActingUser", vc.getSessionVariables(), request );

	if (request.getParameter( ConditionalAreaGroup.HASATTACHMENT ) == null) {
		// set the hasAttachment parameter
		try {
			vc.getSessionVariables().put( ConditionalAreaGroup.HASATTACHMENT, "" + IMTypeATNM.hasAttachment( parStudy ) );
		}
		catch (Throwable th){}
	}

	WorklistResult wlr = WorklistToolbox.staticGetWLR( sess, parStudy );
	boolean isAccessible = wlr.isInAccessList( parStudy );

	String parKey = request.getParameter( "cKey" );
	String strViewSessionID = request.getParameter("ViewSessionID");

	Helper.DEBUG( "reportview.jsp runs 2" );

	if ( parKey == null ) {
		if( !isAccessible ) {
			// check if we were called by a viewer and the study is opened in the viewer and if so, give it a key
			String strVidFileName = IMEnvBase.getEnv( "LOGIN_TMP" ) + "/" + strViewSessionID + ".vid";
			File fVidFile = new File( strVidFileName );
			HashMap<String, FingerPrint> vidFingerprints = null;
			if ( fVidFile.exists() ) {
				vidFingerprints = VIDManager.readStudyFingerprintsFromVID( strViewSessionID );
				if ( vidFingerprints.keySet().contains( parStudy ) ) {
					Helper.DEBUG( "reportview.jsp viewer keygen runs 2" );
					parKey = IMKey.genStudyKey( parStudy, sess.getSessionId() );
				}
			}
		}
	}
	
	try {
		// getRedirectForStudy() does anything only in a CWL environment on the Worklist server
		String redirHost = RedirectToolbox.getRedirectForStudy( sess, parStudy );
		if ( redirHost != null ) {
			String redirURL = redirHost + "/cases/reportview.jsp?" + RedirectToolbox.getRedirectParams( sess, request );
			if ( parKey != null && request.getParameter( "cKey" ) == null ) {
				redirURL += "&cKey="+Helper.URLEncodeUTF8( parKey );
			}
			response.sendRedirect( redirURL );
			return;
		}
	}
	catch (IMException ime) {
		Helper.DEBUG("cases/edit.jsp", Helper.throwable2String(ime));
	}
	boolean isViewer = "true".equals(request.getParameter("cIntegrated"));
	boolean isAjaxSave = "true".equals(request.getParameter("cAjaxSave"));
	if (!ReportToolbox.initSession(sess, request, vc.getSessionVariables() )) {
		// Missing study (cGr)

%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_RV_REPORT_MISSING_DATA" ) %></title>
  <META http-equiv="Refresh" content="5; URL=/cases/index.jsp">
<%
TabToolbox.writeIMpopup(out);
imagemed.http.tabs.TabBean.writeStyleOnly( response.getWriter(  ));%>
    </head><BODY>
<%		/*if (!isViewer false) TabToolbox.makeTabs( sess, sess.tabbean, "cases/index.jsp", "White" ); */ %>
    <CENTER><h2><FONT face="Arial,Helvetica,Universe,Sans-Serif"><%= LocalizedMessage.getSimpleMessage( "CASES_RV_DATA_MISSING" ) %></font></h2></center>
    </body></html>
<%
	return;
	}
	String studyUID = vc.getSessionVariables().getProperty("study");
	if ( studyUID == null ) {
		studyUID = parStudy;
		vc.getSessionVariables().put( "study", parStudy );
	}
	if ( sess.getRights().hasAdminRight() ) { //is admin
		UserFile settingsFile = new UserDir( sess.getUser().getUserId() ).getUserFile( "settings.cfg" );
		if ( settingsFile.prepareForWrite() ) {
			IMProperties.setValueInFile( settingsFile.toString(), "lastreport", studyUID );
		}
	}
  
//	Check if study exists and is accessible for the user
//	String fields[] = { "RPST", "STAT", "PANM", "PAID", "PSEX", "PDOB", "PHRF", "MODY", "ACCN", "DSCR", "SYDT" };

	String SQLtables[]     = { "Dcstudy", "Dcobject" , "" };
	IMFieldManagerImpl fm = new IMFieldManagerImpl("Dcfields", "Dctypes", SQLtables);
	
	TableBrokerFacade tb = Connector.getInstance().get( TableBrokerFacade.Caller );

	TableDescriptorImpl tdesc       = new TableDescriptorImpl();
	WorklistTableParamsImpl tparams = new WorklistTableParamsImpl(tb.getListDescriptor(), sess);

	String[] fields = null;
	String query = "select COLID from Dctables where TABLENAME='Dcstudy'";
	ResultSet resultSet = IMEnv.getDB().prepareStatement(query).executeQuery();
	List<String> fieldList = new ArrayList<String>();
	while (resultSet.next()) {
		fieldList.add(resultSet.getString("COLID"));
	}
	fields = fieldList.toArray(new String[0]);
	tparams.setDefaultFields(fields);

	if (studyUID != null) {
		Properties filters = new Properties();
		filters.setProperty("SYUI",studyUID);
		tparams.setDefaultFilters(filters);
	}

	tdesc.setTableParams(tparams);
	tdesc.setFieldManager(fm);
	WorklistResultImpl dbResult = new WorklistResultImpl( tdesc, sess );
	if ( parKey != null ) {
		if ( !dbResult.isInAccessList( studyUID ) ) {
			Check ch = new Check( studyUID, parKey );
			if ( ch.hasAccess( sess, dbResult, false ) == null ) {
				dbResult.ignoreGlobalRestriction();
			}
		}
	}
	dbResult.setGlobal(true);
	if (!dbResult.next( sess )) {
		if (!OutsideScopeToolbox.isStudyAcknowledged( sess, studyUID )) {
			throw new IMGeneralException("No such study","cases/index.jsp","Report Error", vc.getSessionVariables().getProperty("back"));
		}
	}


	int nWaitTime = 30000; // 30 sec
	Properties prpLock = new Properties();
	Properties prpLastModified = null;
	String lockID = null;


	// Approve interpretation
	boolean bApproveRight = "true".equals(tryToGetParamAndStore( "bApproveRight", vc.getSessionVariables(), request ));

	boolean bApprove = "Approve".equals(request.getParameter("cOp"));
	boolean isApprove1 = bApprove && bApproveRight;	
	boolean isApprove = ReportToolbox.checkAndDoApprove(sess, vc.getSessionVariables(), request, prpLock, nWaitTime);
	// checkAndDoApprove filled locks and breaks into prpLock 
	if (isApprove1 && !isApprove) { 
		// approve is finished, we should return to cases/index...
		String back  = tryToGetParamAndStore( "back", vc.getSessionVariables(), request );
		response.sendRedirect(back);
		return;
	}

	//  Save data
	String origStudy = studyUID;
	if (isAjaxSave) {
		// check for int0_statid, if it's missing the statusinputmacro is missing which would result in corrupt/incomplete saving
		if (request.getParameter( "int0_statid" ) == null) {
			response.addHeader("ajaxSaveResult", "Mandatory parameter \"int0_statid\" missing, maybe your edit report template does not contain a statusinputmacro.");
			return;
		}
	}
	String strSaveError = ReportToolbox.checkAndDoSave(sess, vc.getSessionVariables(), request, !isAjaxSave);
	if (isAjaxSave) {
		response.addHeader("ajaxSaveResult", strSaveError==null?"OK":strSaveError);
		return;
	}
	String newStudy = tryToGetParamAndStore( "study", vc.getSessionVariables(), request );

	// Reports created for orders are saved with proposedStudyUID.
	// Check if the new study exists use it for showing the report
	if (!"".equals(newStudy) && !origStudy.equals(newStudy)) {
		Properties filters = new Properties();
		filters.setProperty("SYUI", newStudy);
		tparams.setDefaultFilters(filters);
		WorklistResultImpl dbResultNew = new WorklistResultImpl( tdesc, sess );
		dbResultNew.setGlobal(true);
	   	if (dbResultNew.next( sess )) {
			dbResult = dbResultNew;
			studyUID = newStudy;
		}
	}


	// They can't be changed via function calls from this point
	boolean bEdit  = "true".equals(tryToGetParamAndStore( "bEdit", vc.getSessionVariables(), request ));
	boolean bReportRight = "true".equals(tryToGetParamAndStore( "bReportRight", vc.getSessionVariables(), request ));
	boolean isEdit = bEdit && bReportRight;
	boolean isBatchApprove = "batchApprove".equals(tryToGetParamAndStore( "cOp", vc.getSessionVariables(), request ));

	boolean bNeedUnlock = !isViewer && (isEdit || isApprove || isBatchApprove);

	// if not accessible (from viewer) we go to view mode
	if( !isAccessible ) {
		vc.getSessionVariables().put("bAccessible", "false");
		if( isEdit ) {
			bEdit = false;
			isEdit = false;
			vc.getSessionVariables().put("bEdit", "false");
		}
	}

	
	String pid = String.valueOf(Helper.getCounter());

	String dbStatus = dbResult.getValue( sess, "RPST", "0"); // Report Status
	if ("0".equals(dbStatus)) {
		dbStatus = dbResult.getValue( sess, "STAT", "0");  // Main Status
	}

	/*
		Parse report file
	*/

	// Parameters might be changed
	Properties results = new Properties();
	Vector<Properties> interpretations = new Vector<Properties>();
	Vector<Properties> externals = new Vector<Properties>();
	Properties newInt = null;         // for creating new interpretations
  
	int res = ReportToolbox.parseReport(sess, origStudy, false, results, interpretations, externals);
	if (res == 1) {
//		throw new imagemed.exception.IMGeneralException("Invalid report version, the report should be converted", "cases/index.jsp", "Invalid Report version", null);
	}
	else if (res > 0) {
		throw new imagemed.exception.IMGeneralException("An error occured while reading report", "cases/index.jsp", "Error reading report", null);
	}

%><%-- HTML ------------------------------------------------------------- --%><%

	String dispPName  = IMType.getTypeFor("PN").display( sess, dbResult.getValue( sess, "PANM","") );    // Patient Name
	String dispPaID = dbResult.getValue( sess, "PAID","");
	String dispStyDate = IMType.getTypeFor( "DA").display( sess, dbResult.getValue( sess, "SYDT","") );
	String dispAccNo = dbResult.getValue( sess, "ACCN","");
	String dispRefPh  = IMType.getTypeFor("PN").display( sess, dbResult.getValue( sess, "PHRF","") );    // Referring Physician
	String birthDate =  dbResult.getValue( sess, "PDOB","");                    // Patient Birth Date
	int bdPos = birthDate.indexOf("_");
	if (bdPos != -1) {
		birthDate = birthDate.substring(0,bdPos);
	}
	String dispDate = IMType.getTypeFor("DA").display( sess, birthDate );

	String urlName = tryToGetParamAndStore( "urlName", vc.getSessionVariables(), request );
	if (urlName == null) {
		urlName = request.getRequestURI(  );
		vc.getSessionVariables().put( "urlName", urlName );
	}
	String urlParam = tryToGetParamAndStore( "urlParam", vc.getSessionVariables(), request );

	String reportTitle = "Report - " + dispPName + " / " + dispPaID + ", " + dispStyDate + ", " + dispAccNo;
	if ( "true".equals( request.getParameter( "queryTitle" ) ) ) {
		out.println( "\n"+reportTitle );
		return;
	}
	// FIXME: SpeechEngine
	String ieVersion = ReportFunctions.getReportPanelSetting( "ieVersion", sess, "" );
if (!ieVersion.equals("0")) {
	response.setHeader( "X-UA-Compatible", "IE="+ieVersion );
%><!DOCTYPE html>
<%} %>
<HTML>
<HEAD>
<%if (!ieVersion.equals("0")) {
%><meta http-equiv="X-UA-Compatible" content="IE=<%=ieVersion%>"><%} %>
<META HTTP-EQUIV="Pragma" CONTENT="no-cache">
<META HTTP-EQUIV="Expires" CONTENT="-1">
<TITLE><%= reportTitle %></title>
  
<%
	
	imagemed.http.tabs.TabBean.writeStyleOnly(new PrintWriter(out, true));
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(new PrintWriter(out, true));
	
	if (isEdit && !isViewer && !isBatchApprove) {
		String strMessageType =  ReportToolbox.checkReportLock(sess, vc.getSessionVariables(), request, prpLock, nWaitTime);
		if (strMessageType != null) {
			bEdit = false;
			isEdit = false; // isEdit is a shortcat for bEdit && bReportRight
			vc.getSessionVariables().put("bEdit", "false");
			vc.getSessionVariables().put("messageType", strMessageType);
		}
		else {
			lockID = prpLock.getProperty("IMLockID");
			vc.getSessionVariables().put("lockId", lockID);			
		}
	}
	
	// manage lockId whenever possible; even Approve+Cancel needs lockId to unlock study
	if (!isEdit && !isViewer && !isBatchApprove) {
		lockID = prpLock.getProperty("IMLockID");
		if (null != lockID && !"null".equals( lockID )) {
			vc.getSessionVariables().put("lockId", lockID);
		}
	}
	
	JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );
	if (isEdit) {
		// load flexselect library
		JSHelper.printJsInclude( out, JSHelper.LIQUIDMETAL_JS );
		JSHelper.printJsInclude( out, JSHelper.FLEXSELECT_JS );
		out.println( StyleToolbox.getStylePart( "flexselect" ) );
	}
	JSHelper.printJsInclude( out, "/cases/js/ReportScripts.js" );
	JSHelper.printJsInclude( out, "/cases/js/sc.js" );
	JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
	out.flush(  );
	RichTextAreaInputMacro.printIncludeAndInit(response.getWriter(  ));
	//JSHelper.printJsInclude( out, "/cases/js/sc.js" );
%>
<SCRIPT>
<%
	// FIXME: speechEngine
	ReportFunctions.printJsSettings( sess, "" );
%>

	var bChanged = false;
	var needUnlock = <%= bNeedUnlock ? 1 : 0 %>; // in default unlock study when leaving page

	var submitted = false;
	
	function doSubmit(frm, mod) {
		if ( submitted ) { // prevent double clicks
			return;
		}
		submitted = true;
		try {
			updateRTEs();
		}
		catch (e){}
		needUnlock = 0;  // in case of save study should not be unlocked
		if (frm.cOp != null){
			while (frm.cOp.value != mod) {
				frm.cOp.value=mod;
			}
		}

		frm.submit();
	}

	var prevContent;
	
	var changeCount = 0;

	function doBASubmit(frm, mod) {
		// mods are 'prev', 'next', 'unapprove', 'approve', 'finish', 'cancel'
		if ( pageLoaded != true ) {
			return;
		} 
		if ( mod != "cancel" ) {
			// we might want to save
			var doAsk = mod == "prev" || mod == "next" || mod == "unapprove" || mod == "finish";
			if ( !ajaxSave(doAsk)) {
				// wanted to save, but saving failed. Do not leave the page.
				return;
			}
		}
		doSubmit(frm, mod);
	}

	function ajaxSave(doAsk) {
		var currentContent = getAllContent( true );
		if ( currentContent == prevContent || ( doAsk && !confirm( "The report has been modified. Save changes?" ) ) ) {
			return true;
		}
		if ( !popupXmlHttp ) {
			alert("Sending report failed: popupXmlHttp is null. Your browser might not be supported.");
			return false;
		}
		var post = currentContent + "&cOp=Save&cAjaxSave=true<%= userManager.isSessionRemote( sess.getSessionId() )?"&ParentSession="+sess.getSessionId( ):""%>&cChangeID=<%=System.currentTimeMillis()%>.<%=Helper.getCounter()%>_" + changeCount + "&cIMLockID=<%=lockID%>";
		popupXmlHttp.open( 'POST', "/cases/reportview.jsp?baAjaxSave=<%=Helper.URLEncodeUTF8( sess.getUser(  ).getUserId(  ))%>__"+escape(navigator.userAgent), false );
		popupXmlHttp.setRequestHeader( 'Content-Type', 'application/x-www-form-urlencoded' );
		popupXmlHttp.send( post );
		var response = popupXmlHttp.getResponseHeader("ajaxSaveResult");
		if ( "OK" == response ) {
			// success
			prevContent = currentContent;
			changeCount++;
			return true;
		}
		if (popupXmlHttp.status != 200) {
			response = "network communication problem [" + popupXmlHttp.status + "]: " + popupXmlHttp.statusText;
		}
		if (response == "" || response == null) {
			response = popupXmlHttp.responseText;
		}
		alert("Sending report failed: "+response);
		changeCount++;
		return false;
	}
	
	function unlockStudy() {
		<%
			String studyPart = "study="+studyUID;
			if (isBatchApprove) {
				studyPart = "cContext="+request.getParameter("cContext");
				if (userManager.isSessionRemote( sess.getSessionId() )) {
					studyPart += "&cProxy=true";
				}
			}
		%>
		studyPart='<%=studyPart%>';
		if (needUnlock) {
			try {
				console.log( "unlocking started" );
			}
			catch (e){}
			$.ajax({
	  			type: 'POST',
	  			url: '/cases/unlockwindow.jsp',
	  			data: studyPart+'&cIMLockID=<%=lockID+(userManager.isSessionRemote( sess.getSessionId() )?"&ParentSession="+sess.getSessionId(  ):"")%>',
				async:false,
				success: function() {
					needUnlock = false;
					try {
						console.log( "unlocking succeeded" );
					}
					catch (e){}
			    },
				error: function (xhr, ajaxOptions, thrownError) {
					try {
						console.log( "unlocking failed:" );
				    	console.log(xhr.status);
				    	console.log(thrownError);
					}
					catch (e){}
				}
			});
		}
	}

	$(document).ready(function(){
		window.onbeforeunload = function(){
			unlockStudy();
		}
	});

	function changeSize(imgsize, dose) {
		l=imgsize.options[imgsize.selectedIndex].value; 
		if(l!="") l="cSize="+l; 
		l="<%=urlParam%>"+l;
		if(l!="") l="?"+l;
		if( dose != "" ) {
			l += "&cDose=" + dose;
		}
		document.location.href="<%=urlName%>"+l;
	}

	function changeDose(dose, imagesize) {
		l=dose.options[dose.selectedIndex].value; 
		if(l!="") l="cDose="+l; 
		l="<%=urlParam%>"+l;
		if(l!="") l="?"+l;
		if( imagesize != "" ) {
			l += "&cSize=" + imagesize;
		}
		document.location.href="<%=urlName%>"+l;
	}

	function openPrintFriendly(url) {
		if ( <%= bEdit?"true":"false" %> && window.confirm('Save your work?') )
			doSubmit(self.document.saveForm,'Save');
		window.open(url,"imw_printfriendly","resizable=yes,scrollbars,toolbar=yes,menubar=yes");
	}

	function doFocusing() {
		button = document.getElementById("defaultButton");
		if (button) {
			button.focus();
		}
	}
	
	function openInHiddenFrame(url) {
		document.getElementById("hiddenFrame").src = url;
	}

	<%
	{
		String parentSessionPart = "";
		String ps = vc.getSessionVariables().getProperty( "ParentSession" );
		if ( ps != null && ps.length() > 0 ) {
			parentSessionPart = "&ParentSession=" + ps;
		}
	%>
	radarPanelURL = "<%= requestInfo.getHttpsHost()%>/cases/radar.jsp?cStudy=" + <%=JSHelper.toJSON( studyUID + parentSessionPart )%>;
	<%
	}
	%>
	
</SCRIPT>
<%
	boolean bMessageWindow = (null != vc.getSessionVariables().getProperty("messageType"));
	String study       = studyUID;
	String patientName = dbResult.getValue( sess, "PANM" );  // Patient Name
	String modality    = dbResult.getValue( sess, "MODY" );  // Modality
	String studyDate   = dbResult.getValue( sess, "SYDT" );  // Study Date

	boolean isWebViewer = "true".equals( request.getParameter( "isWebViewer" ) );

	boolean bPrintFriendly = "true".equals( request.getParameter( "cPrintFriendly"));

	boolean bNeedPrint = false;
	if (bPrintFriendly) { // in custom report we don't use style...
%>
    <STYLE TYPE="text/css">
    TD.deftd { font-family: arial, helvetica, universe, sans-serif; }
    TD.instname { font-family: arial, helvetica, universe, sans-serif; font-size: 10pt; font-weight: bold; }
    TD.rtitle { font-family: arial, helvetica, universe, sans-serif; font-size: 18pt; font-weight: bold; }
    P.element { margin: 0em 0em; padding-top: 0em; padding-bottom: 0.3em; font-size: 13pt; }
<%		if (false /*!sess.isMSIE()*/) {%>
		TD {
			font-family: arial, helvetica, universe, sans-serif;
			vertical-align: middle;
			font-size: 13pt;
		}
<%		}
%>
		</STYLE>
<%
		bNeedPrint = ! "true".equals(request.getParameter("cDontPrint"));
/*		if (sess.bIsMSIE) {
			try {
				int p = sess.ua.indexOf("MSIE ");
				if (p != -1) {
					p += 5;
					while( sess.ua.charAt(p) == ' ')
						p++;
					if (sess.ua.charAt(p) <= '4') {
						bNeedPrint = false;
					}
				}
			}
			catch (Throwable th) {
			}
		}*/

		boolean isFax = "yes".equals( request.getParameter("cFax") );
		String action = isFax ? "fax" : "print";
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, action );
		logEntry.setField( OperLogEntry.FIELD.USER, ( parActingUser != null && !"null".equals( parActingUser ) ? parActingUser : sess.getUser().getUserId(  ) ) );
		logEntry.setField( OperLogEntry.FIELD.STUDY, study );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		if( isFax ) {
			logEntry.setField( OperLogEntry.FIELD.FAX_NUMBER, request.getParameter( "cFaxNo" ) );
		}
		logEntry.log( sess, "reportview", 0, Syslog.LOG_INFO );

//		Syslog operLog = new Syslog("reportview", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		operLog.syslog(Syslog.LOG_INFO, "INFO STUDY print " + sess.regID + " - " +
//				study + " " + patientName + " " + modality + " - - - - - - - " + Syslog.logValue( dispStyDate ) );
	}
	else {
%>
    <STYLE TYPE="text/css">
    A { text-decoration:none; }
    TD.menu  { font-family: arial, helvetica, universe, sans-serif; font-size: 10pt;}
    TD.deftd { font-family: arial, helvetica, universe, sans-serif; }
    TD.instname { font-family: arial, helvetica, universe, sans-serif; font-weight: bold; font-size: small; }
    TD.rtitle { font-family: arial, helvetica, universe, sans-serif; font-size: large; font-weight: bold; }
<%		if (false) { // FIXME: isMSIE %>
		TD {
			font-family: arial, helvetica, universe, sans-serif;
			vertical-align: middle;
			font-size: 13pt;
		}
<%		}
			if (isViewer || isWebViewer) {%>
			BODY {
				padding: 0px;
				margin: 0px;
			}
	<%
			}
%>
    </STYLE>
<%
	}
	String onLoad = "";
	if (bNeedPrint) {
		onLoad="addLoadEvent( window.print );";
	}
	else if (isBatchApprove) {
		onLoad="addLoadEvent( batchStartup );";
	}
%>

<Script language="JavaScript">
	<%=onLoad%>

	function cancelUnlocking() {
		studyPart='<%="cContext="+request.getParameter("cContext")+(userManager.isSessionRemote( sess.getSessionId() )?"&ParentSession="+sess.getSessionId(  )+"&RefererHost="+RedirectToolbox.getReferringHost(sess):"")%>';
		jsPopup('/cases/batchReportSign.jsp?cOp=abortUnlock&'+studyPart, 'unlockwindow',false);
	}

	function batchStartup() {
		setTimeout("doFocusing()", 100);
		setTimeout("cancelUnlocking()", 5000);
		prevContent = getAllContent( true );
	}
</script>

</head>

<BODY onUnload='unlockStudy();'>
	<IFRAME id="hiddenFrame" style="display:none"></IFRAME>
    <script language="javascript" src="/Evo/reportbuttons/reportbuttons.nocache.js"></script>

<%
//if (!(isViewer || isWebViewer)) TabToolbox.makeTabs( is, sess.tabbean, "cases/index.jsp", "White" ); // hmmm , false
%>
<%if (/*sess.isCurl()*/ false) { // FIXME: curl %>
<FONT face="Arial,Helvetica,Universe,Sans-Serif">
<%}%>
<CENTER>
<%

	// print message windows if needed
	if (ReportToolbox.checkAndPrintMessageWindow(sess, vc.getSessionVariables(), request, new PrintWriter(out, true), prpLock)) {
		return;
	}

	if (strSaveError != null) {
		newInt = new Properties();
		ReportToolbox.setPropertiesFromRequest(sess, session, request, results, interpretations, newInt);

%><font color="red"><b><%= strSaveError %></b></font><br><%
	}

	if ("true".equals(vc.getSessionVariables().getProperty("RemoteWarning"))) {
%><b>Copies of this report exist on other servers. The state reported on the<BR>
local worklist and report will change after all copies have been updated.</b><br><%
	}


%><%-- *********************** BEGINING of REPORT table ************************ --%><%

	if (isEdit) {
%>
  <FORM action="<%=urlName%>" method=post name="saveForm">
<%
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "editreport" );
		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
		logEntry.setField( OperLogEntry.FIELD.STUDY, study );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		logEntry.log( sess, "reportview", 0, Syslog.LOG_INFO );

//		Syslog operLog = new Syslog("reportview", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		operLog.syslog(Syslog.LOG_INFO, "INFO STUDY editreport " + sess.regID + " - " +
//				study + " " + patientName + " " + modality + " - - - - - - - "+Helper.URLEncodeUTF8(dispStyDate));
	}
	else if (!bPrintFriendly) { // ! isEdit
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "viewreport" );
		logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
		logEntry.setField( OperLogEntry.FIELD.STUDY, study );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, modality );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		logEntry.log( sess, "reportview", 0, Syslog.LOG_INFO );

//		Syslog operLog = new Syslog("reportview", 0 , IMEnvBase.getEnv("LOG_OPER_FACILITY"));
//		operLog.syslog(Syslog.LOG_INFO, "INFO STUDY viewreport " + sess.regID + " - " +
//				study + " " + patientName + " " + modality + " - - - - - - - "+Helper.URLEncodeUTF8(dispStyDate));

		String back  = vc.getSessionVariables().getProperty("back");
%>
    <FORM action="<%= urlName %>" name="editForm" style="display: none;">
    <%=ReportToolbox.getCommonHidden(sess, vc.getSessionVariables(), request, "			", "edit")%>
    </FORM>
<%
	}

	int lastEpRangesAssignValue = IMTypeos.getLastEPRangesAssignValue();
	int borderValue = lastEpRangesAssignValue;
	int[] lastEpRangeBorders = IMTypeos.getSuitableRangeMinRangeMaxBorders( String.valueOf( lastEpRangesAssignValue ) );
	if ((lastEpRangeBorders != null) && (lastEpRangeBorders.length == 2)){
		borderValue = lastEpRangeBorders[0];
	}
	String reportType = ( Integer.parseInt( dbStatus ) < borderValue ) ? ( IMTypeos.getDisplayedValue( String.valueOf( IMTypeos.getApprovableEPRangesAssignValue() ) ) ) : ( IMTypeos.getDisplayedValue( String.valueOf( lastEpRangesAssignValue ) ) );
	
	if (interpretations.size() == 0 && !isEdit) {
		reportType = "Empty";
	}
	if (reportType.equals("Empty")) {
		out.println("<P><TABLE width=\"100%\" cellpadding=7 cellspacing=1 border=0>");
		ReportToolbox.printPageHeader(sess, vc.getSessionVariables(), request, new PrintWriter(out, true), externals.size() > 0?"External":reportType);
		out.println("</TABLE>");
		if (externals.size() == 0)
			return; // no data to show
	}

//	dispResults.setProperty("reason", results.getProperty("reason", dbResult.getValue("DSCR","")));
//	dispResults.setProperty("impression", results.getProperty("impression",""));

	// Get REPORT interpretation
	vc.getSessionVariables().remove( "pics");
	vc.getSessionVariables().remove( "picSizes");

	int numOfInterpretations = interpretations.size();
	boolean needNewInterpretation = true;
	int reportIndex = -1;
	int intCounter = 0;

	if (numOfInterpretations > 0 || isEdit) { // || externals.size() > 0) {
		for (int i = 0; i < numOfInterpretations; i++) {
			Properties interpretation = interpretations.elementAt(i);
			InterpretationInfo ii = ReportToolbox.processInterpretation(interpretation); 
			boolean isFinal = ii.isFinal();
			
			// Sorry. This is needed because the macros that print the key image
			// count, and the images read them from the sessionVariables.
			// Yes, I know what you think... this was inherited. This really
			// needs refactoring, but now it was quicker this way (RSNA mode
			// on).
 
			{
				{ // picSum
					String picSum = vc.getSessionVariables().getProperty( "picSum" );
					if ( null == picSum )
						picSum = "0";
					
					int sumKeyImages = 0;
					try {
						sumKeyImages = Integer.parseInt( picSum );
					}
					catch ( Throwable th ) {
					}
					
					picSum = "" + (sumKeyImages + ii.getPicNum());
					
					vc.getSessionVariables().setProperty( "picSum", picSum );
				}
				
				{ // pics
					String pics = vc.getSessionVariables().getProperty( "pics" );
					if (null == pics)
						pics = "";
					for (String p : ii.getPics())
						pics += p + "\n";
					vc.getSessionVariables().setProperty( "pics", pics );
				}
				
				{ // picSizes
					String picSizes = vc.getSessionVariables().getProperty( "picSizes" );
					if (null == picSizes)
						picSizes = "";
					for (String p : ii.getPicSizes())
						picSizes += p + "\n";
					vc.getSessionVariables().setProperty( "picSizes", picSizes );
				}
			}
			
			needNewInterpretation = needNewInterpretation && isFinal;
			if ("REPORT".equals(interpretation.getProperty("typeid")) && reportIndex == -1) {
				reportIndex = i;
			}
		}

		Properties reportInterpretation = null;
		if (reportIndex == -1) {
//			String date = Helper.longToDateTime(System.currentTimeMillis());
			TimeStamp ts = new TimeStamp( true, sess );
//			if ( sess.getTimeZone() != null ) {
//				ts.convertTo( sess.getTimeZone() );
//			}

			String name = null;
			try { 
				name = Helper.getUserName( sess, sess.getUser(  ).getUserId(  )); 
			} 
			catch (Throwable th) {
				%><!-- <%=Helper.toString(th)%> --><%
			}

			reportInterpretation  = new Properties();
			reportInterpretation.setProperty("typeid", "REPORT");
			if (name != null) {
				reportInterpretation.setProperty("author", name);
				%><!-- author name set to <%=name%> --><%
			}
			else {
				%><!-- sess.regID=<%= sess.getUser(  ).getUserId(  )%> --><%
			}
			reportInterpretation.setProperty( "recdate", ts.getDA() );
			reportInterpretation.setProperty( "rectime", ts.getTM() );
// 			reportInterpretation.setProperty("recdate",date.substring(0,8));
//			reportInterpretation.setProperty("rectime",date.substring(8));
			reportInterpretation.setProperty("text", "");
			if (isEdit) { %>
				<input type="hidden" name="int0_isNew" value="true">
			<%
			}
			reportInterpretation.putAll(results);
			interpretations.add(0, reportInterpretation);
			needNewInterpretation = false;
		}
		else {
			reportInterpretation = interpretations.elementAt(reportIndex);
			interpretations.removeElementAt(reportIndex);
			reportInterpretation.putAll(results);
			interpretations.add(0, reportInterpretation);
		}
		
		if (!"APPROVED".equals(reportInterpretation.getProperty("statid"))) {
			reportInterpretation.setProperty("InterpretationNum",""+intCounter);
			intCounter++;
		}

		// Process NON Report Interpretations

		for (int i = 1; i< interpretations.size(); i++) {
			Properties interpretation = interpretations.get(i);
			interpretation.setProperty("InterpretationNum","" + intCounter);
			if (!"APPROVED".equals(interpretation.getProperty("statid"))) {
				intCounter++;
			}
		}

		if ( isEdit ) {
			if ( needNewInterpretation ) {
				if ( newInt == null ) {
					newInt = new Properties();
//					String date = Helper.longToDateTime( System.currentTimeMillis() );
					TimeStamp ts = new TimeStamp( true, sess );
//					if ( sess.getTimeZone() != null ) {
//						ts.convertTo( sess.getTimeZone() );
//					}
						
					String name = null;
					try { 
						name = Helper.getUserName( sess, sess.getUser(  ).getUserId(  ) ); 
					} 
					catch (Throwable th) {
					}

					if ( name != null ) {
						newInt.setProperty("author", name);
					}
//					newInt.setProperty( "recdate", "20140426" );
//					newInt.setProperty( "rectime", "110000" );
					newInt.setProperty( "recdate", ts.getDA() );
					newInt.setProperty( "rectime", ts.getTM() );
					newInt.setProperty( "isNew", "true" );
					newInt.setProperty( "text", "" );
				}
				newInt.setProperty( "InterpretationNum", "" + intCounter );
				newInt.setProperty( "typeid", ( numOfInterpretations == 0 ) ? "REPORT" : "AMENDMENT" );
				interpretations.add( newInt );
			%>
				<input type="hidden" name="int<%=intCounter%>_isNew" value="true">
			<%
			}

			out.println(ReportToolbox.getCommonHidden(sess, vc.getSessionVariables(), request, "	", "Save"));
				      
			//	String back  = sessionVariables.get("back");

			//	Hidden fields
			//	if (back != null) {
				%><%--
      <INPUT type="hidden" name="cBack" value="<%= back %>">
  <%
//			}
  %>
      <INPUT type="hidden" name="cOp" value="Save">
      <INPUT type="hidden" name="cGr" value="<%= study %>">
      <INPUT type="hidden" name="cIMLockID" value="<%= lockID %>">--%>
      <INPUT type="hidden" name="cChangeID" value="<%="" + System.currentTimeMillis() + "." + Helper.getCounter() %>">
  <%
    		if ( results.getProperty( "res_sopiuid" ) != null ) {
   		 		String sopiuid = results.getProperty("res_sopiuid");
    			if (sopiuid != null) {
		    		out.println("<INPUT TYPE=HIDDEN NAME=\"results_sopiuid\" VALUE=\"" + sopiuid + "\">");
    			}
    		}
    	} // if (isEdit)

   	} // if (numOfInterpretations > 0 || isEdit)
    	
   	OperatingMode mode = LayoutPart.VIEWING;
   	String layoutPart = LayoutPart.REPORTLAYOUT;
   	if (isWebViewer) {
   		layoutPart = LayoutPart.WVREPORTLAYOUT;
   	}
   	else if (isViewer) {
   		if (isEdit) {
   			layoutPart = LayoutPart.REPORTEDITLAYOUT;
   			mode = LayoutPart.VIEWEREDITING;
   		}
   	}
   	else if (isEdit) {
   		layoutPart = LayoutPart.REPORTEDITLAYOUT;
   		mode = LayoutPart.EDITING;
   	}
   	else if (bPrintFriendly) {
   		mode = LayoutPart.PRINTFRIENDLY;
   	}
   	else if (isBatchApprove) {
   		layoutPart = LayoutPart.REPORTEDITLAYOUT;
   		mode = LayoutPart.BATCHAPPROVING;
   	}
   	LayoutBuilder builder = new LayoutBuilder( sess, false, null, "" );

	LayoutRoot root = imagemed.layout.cache.LayoutCache.getSystemLayout(sess, layoutPart, false, sess.getUser().getUserId(), null, false);
   	long time = System.currentTimeMillis();
   	
   	if (interpretations.size() == 0) {
   		// No report but there are externals
   		LayoutRoot cachedRoot = root;
   		root = LayoutRoot.createLayoutRoot( layoutPart, builder );
   		root.getChildren().set(0, cachedRoot.getChildren().get(0).clone( sess, root ));
   		root.trimTreeUpToType(LayoutPart.TYPEEXTERNAL);
   	}
   	Helper.DEBUG( "reportdatasource, study:" + studyUID );
   	vc.getSessionVariables().put( "urlName", request.getRequestURI() );
   	String test = vc.getSessionVariables().getProperty( "study" );
   	Helper.DEBUG( "study in vc:" + test );
   	HtmlVisitor htmlVisitor = new HtmlVisitor(mode, new ReportDataSource( sess, interpretations, externals, studyUID ), vc);
   	//DebugVisitor debugVisitor = new DebugVisitor( htmlVisitor );
   	root.accept( sess, htmlVisitor );
   	String html = htmlVisitor.getContent();
//    	String html = root.getHtml( "  " + ( isEdit ? "  " : "" ), mode, new ReportDataSource( sess, interpretations, externals, studyUID ) );
   	long delay = System.currentTimeMillis() - time;
   	out.println("</center>\n");
   	if (bPrintFriendly) {
   		html = html2psFix(html);
   	}
   	out.println(html);
   	if (isEdit) {
  %>
  </FORM>
<%
	}
   	IMProperties guiConf = IMEnv.getConfigProperties( IMEnv.GUI_CONF );
   	boolean shouldDebug = ( "true".equals( guiConf.getProperty( "showJSDebug" ) ) || 
    			                    guiConf.getValueSet( "showJSDebug" ).contains( sess.getUser().getUserId(  ) ) ) && isViewer;
   	if (shouldDebug) {
 		out.println("<center style=\"font-size:50%\"><a href=\"javascript:void showDEBUG();\">show/hide javascript log</a>&nbsp;&nbsp;&nbsp;<a href=\"javascript:void clearDEBUG();\">clear javascript log</a></center>");
   	}
 	if (/*sess.isCurl()*/ false) { // FIXME: what
%>
</FONT>
<%}%>
<!-- <br>
<a href=javascript:alert(getAllContent())>test getInputValues</a>
&nbsp;&nbsp;&nbsp;<a href=javascript:alert(escape(getInputFieldContent(getFocusedFieldName())))>getInputFieldContent</a>
&nbsp;&nbsp;&nbsp;<a href=javascript:alert(getInputFieldContent(getFocusedFieldName()))>getText</a>
&nbsp;&nbsp;&nbsp;<a href=javascript:alert(getTweakedPlainText(getFocusedFieldName()))>getTweakedPlainText</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getFocusedFieldName());">getFocusedElement</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:scrollToField('int0_text' );">scrollToField</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getSelectionStart(getFocusedFieldName())+'-'+getSelectionEnd(getFocusedFieldName()));">get selection</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getElementSelectionTest(returnRTE(getFocusedFieldName())));">get selection test</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(escape(getSelectedText()));">get selection content</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:alert(getPreRangeText());">get preRange content</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void replaceSelection( getFocusedFieldName(), prompt('text', ''));">replace selection</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void replaceSelection( getFocusedFieldName(), '\n');">replace selection with NL</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void setSelection(getFocusedFieldName(), prompt('from',0), prompt('to',0));">set selection</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void checkSize(null,getFocusedFieldName());">check size</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void pbjs.testme();">test pbjs.testme()</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void alert(eval(prompt('javascript code:')));">eval JS code</a>
&nbsp;&nbsp;&nbsp;<a href="edit.html">edit.html</a>
&nbsp;&nbsp;&nbsp;<a href="divTest.html">testDiv.html</a>
&nbsp;&nbsp;&nbsp;<a href="testUndoIframe.html">testUndoIframe.html</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void document.execCommand('undo', false, null)">UNDO</a>
&nbsp;&nbsp;&nbsp;<a href="javascript:void toggleEntertainment()" id="entertainmentToggler">toggleEntertainment</a>
<br>-->
<script>

//writeRichText('impresssion', 'putty', '', '100%', true);
function sleep(miliseconds) {
	var currentTime = new Date().getTime();
    while (currentTime + miliseconds >= new Date().getTime()) {
    }
};
       
var isEntertaining = false;
function toggleEntertainment() {
	isEntertaining = !isEntertaining;
	if (isEntertaining) {
		entertain();
	}
	document.getElementById("entertainmentToggler").style.backgroundColor=isEntertaining?"green":"";
};

function entertain() {
	if (!isEntertaining) {
		return;
	}
	sleep(100);
	setTimeout(entertain, 900);
}

function getSelectedText() {
	var txt = getInputFieldContent(getFocusedFieldName());
	var sel = getFieldSelection(getFocusedFieldName());
	return txt.substring(sel[0], sel[1]);
};

function getPreRangeText() {
	var element = returnRTE(getFocusedFieldName());
	element.focus();
	var sel = window.getSelection();
	var range = sel.getRangeAt( 0 );
	var res = getTextDom( element, new RangeBoundary( range.startContainer, range.startOffset ) );
	return escape(res)+" "+res.length;
};

function pitty() {
	var Editor = frames['testFrame'];
	alert(Editor);
	var window = Editor.window;
	alert(window);
	var document = window.document;
	alert(document);
	document.designMode = "On";
	try {
		Editor.execCommand( "styleWithCSS", 0, false );
	} catch ( e ) {
		try {
			Editor.execCommand( "useCSS", 0, true );
		} catch ( e ) {
			try {
				Editor.execCommand( 'styleWithCSS', false, false );
			} catch ( e ) {
				// alert( "Setting editor to non-css mode failed. (" + e + ")"
				// );
			}
		}
	}
	
}
// var testText = document.getElementById('testText');
//if ( testText.addEventListener ) {
// testText.addEventListener( 'keyup', function() {
// alert( "testText" );
// }, false );
// } else if ( testText.attachEvent ) {
// testText.attachEvent( 'onkeyup', function() {
// alert( "testText" );
// } );
// }
// testText.onkeyup = function() {
// alert( "testText" );
// };

var testBackup = "";

function backup() {
	testBackup = getAllContent();
	return false;
}

function restore() {
	setInputValues(testBackup);
	return false;
}

function testme() {
	if (typeof(pbjs) != 'undefined') {
		pbjs.testme();
	}
}


function getScrollPositionYTest() {
	alert([document.body.scrollTop, window.pageYOffset]);
	if ( typeof document.body.scrollTop != 'undefined' ) {
		return document.body.scrollTop
	}
	return window.pageYOffset;
};


function getElementSelectionTest( element ) {
	DEBUG( "called getElementSelection(" + element + ")" );
	// The current selection
	var fullText = getText( element );
	if ( document.activeElement == element ) {
		return;
	}
	var x = getScrollPositionX();
	var y = getScrollPositionYTest();
	element.focus();
	setScrollPosition( x, y );
	return [y, getScrollPositionY()];
	focusWithoutScrolling( element );
	if ( !dontUseHTML5SelectionMode && document.getSelection ) {
		// the html5 way
		var sel = window.getSelection();
		var range = sel.getRangeAt( 0 );
		var begin = getTextDom( element, new RangeBoundary( range.startContainer, range.startOffset ) ).length;
		var end = getTextDom( element, new RangeBoundary( range.endContainer, range.endOffset ) ).length;
		return [ begin, end ];
	}
};


//addLoadEvent(testme);
<%if (shouldDebug) {%>    		
shouldDEBUG = true;
DEBUG();
<%}%>
</script>
</body>
</html>
