#!/bin/sh
#
# Component: iface/scheduler
#
# Description:
#   If there is a Scheduler Module in the hierarchy, generates and sends update message to the Scheduler Module.
#
# Usage:
#   This is a wrapper script around $IFACE_HOME/bin/updateScheduler
#   For usage information see the $IFACE_HOME/bin/updateScheduler
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

LOGGER="/usr/bin/logger"
TAG="updateScheduler[$$]"

$LOGGER -p $LOG_FACILITY.debug -t "$TAG" -- "args: $@"

[ -f "$IFACE_VAR/messageFlow.cfg" ] && . $IFACE_VAR/messageFlow.cfg

[ "true" != "$HasScheduler" ] && exit 0

$LOGGER -p $LOG_FACILITY.debug -t "$TAG" "call c/c++ prog"
$SR_HOME/bin/updateScheduler "$@"
