<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Params:
 *   f - pathinfo : looks like <study><fname>_<frame>[.<size>[w|t]].<ext>
 *                  9.8.7.6/CT.1.2.3.4.5_1[.size[w|t]].ext
 * 
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
-- %><%@
	page import="imagemed.dotcom.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			java.util.*, java.io.*, java.sql.*"

%><%
	IMSession is = new IMSession( request, response, out ); 
	Syslog logger = new Syslog( "getsrdump", 0, IMEnvBase.getEnv( "LOG_FACILITY" ) );

	is.bCheckHttpsAndRedirect = false;
	if ( !is.regOK() ) {
		return;
	}

/* 	is.bRegNotNeeded &= ProxyToolbox.init(is, request, logger);
 */	

	if ( !is.hasRight( imagemed.types.flag.IMTypeur.SUPPORT_RIGHT ) ) {
		response.sendError( 500, "No rights" );
		return;
	}
 
 
	String workID = request.getParameter( "cWork" );


	String workDirName = IMEnvBase.getEnv( "TMP" ) + "/" + workID;
	File workDir = new File( workDirName );
	if ( ! workDir.exists() ) {
		// Should never happen but for safety
		
		String origFormatDirectory = IMEnvBase.getEnv( "SR_VAR" ) + "/format";
		String targetFormatDirectory = workDirName + "/format";
		workDir.mkdir();
		Helper.copyAdvanced( origFormatDirectory, targetFormatDirectory, true, "r" );
	}

 
 
	String oper = request.getParameter( "cOper" );
	if ( "getRules".equals( oper ) ) {
		String cv = request.getParameter( "cCV" ); // concept name code value
		String cs = request.getParameter( "cCS" ); // concept name coding scheme
		
		if ( cv == null || cs == null ) {
			logger.syslog( Syslog.LOG_DEBUG, "Code value or Coding scheme is null" );
			return;
		}

		String ruleSet = request.getParameter( "cRule" );
		if ( ruleSet == null ) {
			ruleSet = "html";
		}

		int homeLength = IMEnvBase.getEnv( "HOME" ).length();
		String srVar = IMEnvBase.getEnv( "SR_VAR" ).substring( homeLength + 1 );
		String srHome = IMEnvBase.getEnv( "SR_HOME" ).substring( homeLength + 1 );
		
		String dirNames[][] = new String[][] {
			// editable, dirname
			{ "true", workDirName + "/format", srVar + "/format" }, 
			{ "false", IMEnvBase.getEnv( "SR_HOME" ) + "/format", srHome + "/format" },
		};

		String fileTypes[] = new String[] {
			"External",
			"Headers"
		};
		
		String fns[] = new String[ 3 ];
		
		Vector<Properties> fileNames = new Vector<Properties>();
		
		for ( String dirName[] : dirNames ) {
			for ( String fileType : fileTypes ) {
				fns[ 0 ] = cs + "/" + cv + "/" + fileType + "." + ruleSet + ".cfg";
				fns[ 1 ] = cs + "/" + fileType + "." + ruleSet + ".cfg";
				fns[ 2 ] = fileType + "." + ruleSet + ".cfg";
				for ( String fn : fns ) {
					String fullName = dirName[ 1 ] + "/" + fn; // Path to the working directory
					Properties p = new Properties();
					p.setProperty( "fname", dirName[ 2 ] + "/" + fn ); // Path to the official place
					p.setProperty( "shortname", fn );
					p.setProperty( "editable", dirName[ 0 ] );
					p.setProperty( "ftype", fileType );
					p.setProperty( "exists", Boolean.toString( new File( fullName ).exists() ) );
					fileNames.add( p );
				}
			}
		}
		out.print( JSHelper.toJSON( fileNames ) );
		return;
	}
	
	if ( "getConfig".equals( oper ) ) {
		String confName = request.getParameter( "cConf" ); // Name of the config file
		String isEditable = request.getParameter( "cEdit" ); // get editable version (custom version)
		
		if ( confName == null ) {
			logger.syslog( Syslog.LOG_DEBUG, "Config name is null" );
			return;
		}
		
		File f = new File( ( "true".equals( isEditable ) ? workDirName : IMEnvBase.getEnv( "SR_HOME" ) )  + "/format/" + confName );
		StringBuilder content = new StringBuilder( 2048 );
		if ( f.exists() ) {
			try ( BufferedReader br = new BufferedReader( new FileReader( f ) ); ) {
				String line = null;
				
				while ( null != (line = br.readLine() ) ) {
					content.append( line ).append( "\n" );
				}
			}
			catch ( Throwable th ) {
				throw new IOException( "Error reading config file: " + Helper.throwable2String( th ) );
			}
			
		}
		Properties values = new Properties();
		values.setProperty( "content", content.toString() );
//		values.setProperty( "filename", f.getAbsolutePath() );
		out.print( JSHelper.toJSON( values ) );
		return;
	}
	
	if ( "getReports".equals( oper ) ) {
		String study = request.getParameter( "cStudy" );
		if ( study == null ) {
			logger.syslog( Syslog.LOG_DEBUG, "Study is null" );
			return;
		}
		
		StringBuilder query = new StringBuilder( 512 );
		query.append( "select FNAME from " ).append( IMEnvBase.getEnv( "OBJECTTBL" ) )
				.append( " natural left join " ).append( IMEnvBase.getEnv( "REPORTTBL" ) )
				.append( " where STYIUID='" ).append( study ).append( "'" );
		// Basic Text SR Storage, Enhanced SR Storage, Comprehensive SR Storage 
		query.append( " AND SOPCLUID IN ('1.2.840.10008.5.1.4.1.1.88.11','1.2.840.10008.5.1.4.1.1.88.22','1.2.840.10008.5.1.4.1.1.88.33')" );
		// Not in the report table
		query.append( " AND Dcreport.SOPIUID IS NULL" );

		Vector<String> reports = new Vector<String>();
		try ( ResultSet rs = IMEnv.getDB().prepareStatement( query.toString() ).executeQuery() ) {
			while ( rs.next() ) {
				reports.add( rs.getString( "FNAME" ) );
			}
		}
		catch ( Throwable th ) {
			throw new IOException( "Error getting report files: " + Helper.throwable2String( th ) );
		}
		
		out.print( JSHelper.toJSON( reports ) );
		return;
	}

	if ( "getDump".equals( oper ) ) {
		String study = request.getParameter( "cStudy" );
		String file = request.getParameter( "cFile" );
	
		if ( study == null || file == null ) {
			logger.syslog( Syslog.LOG_DEBUG, "Study or File is null" );
			return;
		}

		try {
			String studyDirName = RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_DATA_DICOM" ), study );
			if ( studyDirName == null ) {
				response.sendError( 500, "Study was not found in DICOM repository" );
				return;
			}
			if ( ! new File( studyDirName + "/" + file ).exists() ) {
				response.sendError( 500, "Structured report file was not found in study directory " +  studyDirName + "/" + file);
				return;
			}
	
			Vector<String> cmd = new Vector<String>();
			cmd.add( IMEnvBase.getEnv( "DCMTK_HOME" ) + "/bin/dsrdump" );
			cmd.add( "+Pc" );
			cmd.add( studyDirName + "/" + file );
			
			Process proc = Runtime.getRuntime().exec( cmd.toArray( new String[ cmd.size() ] ), null );
			StreamRedirecter stderr = new StreamRedirecter( proc.getErrorStream() );
			stderr.start();
	
			StringBuilder content = new StringBuilder( 2048 );
			String codeValue = null;
			String codingScheme = null;
			String conceptName = null;
			try ( BufferedReader br = new BufferedReader( new InputStreamReader( proc.getInputStream() ) ); ) {
				String line = null;
				
				while ( null != (line = br.readLine() ) ) {
					if ( codingScheme == null ) {
						if ( line.startsWith( "<CONTAINER:(" ) ) {
							StringTokenizer st = new StringTokenizer( line.substring( 12 ), "," );
							codeValue = st.hasMoreTokens() ? st.nextToken() : "";
							codingScheme = st.hasMoreTokens() ? st.nextToken() : "";
							
							try {
								int p1 = line.indexOf( ",\"" );
								int p2 = line.indexOf( "\")", p1 );
								conceptName = line.substring( p1 + 2, p2 );
							}
							catch ( Throwable t ) {
							}
						}
						else {
							continue;
						}
					}
					content.append( Helper.htmlEncode( line ) ).append( "\n" );
				}
			}
			catch ( Throwable th ) {
				proc.destroy();
				throw new IOException( "Error reading Structured Report: " + Helper.throwable2String( th ) );
			}
	
			int exitCode = proc.waitFor();
			proc.destroy();
			
			
			HashMap<String, String> values = new HashMap<String, String>();
			values.put( "content", content.toString() );
			values.put( "codevalue", codeValue );
			values.put( "scheme", codingScheme );
			if ( conceptName != null ) {
				values.put( "conceptname", conceptName );
			}
			
			out.print( JSHelper.toJSON( values ) );
			
		}
		catch ( Throwable th ) {
			throw new IOException( "Error reading Structured Report: " + Helper.throwable2String( th ) );
		}
		
		return;
	}

	
	if ( "saveFile".equals( oper ) ) {
		String content = request.getParameter( "cContent" );
		String file = request.getParameter( "cFile" );
	
		if ( content == null || file == null ) {
			logger.syslog( Syslog.LOG_DEBUG, "Content or File is null" );
			response.sendError( 500, "Content or File is null" );
			return;
		}

/* 		if ( workDirName == null ) {
			logger.syslog( Syslog.LOG_DEBUG, "Work dir is null" );
			response.sendError( 500, "Work dir is null" );
			return;
		}
 */
		if ( ! workDir.exists() ) {
			logger.syslog( Syslog.LOG_DEBUG, "Work dir does not exist" );
			response.sendError( 500, "Work dir does not exist" );
			return;
		}
		
		File f = new File( workDirName  + "/format/" + file );
		if ( ! f.exists() ) {
			File parentDir = f.getParentFile();
			if (! parentDir.exists() ) {
				parentDir.mkdirs();
			}
		}
		
		Helper.writeTextFile( f.getAbsolutePath(), content );
		out.print( "OK " + f.getAbsolutePath() + "::" + content );
		return;

	}

	if ( "applyChanges".equals( oper ) ) {
		if ( ! workDir.exists() ) {
			// should never happen;
			logger.syslog( Syslog.LOG_DEBUG, "Working directory " + workDirName + " des not exist" );
			response.sendError( 500, "Working directory " + workDirName + " des not exist" );
			return;
		}

		String tempID = System.currentTimeMillis() + "." + Helper.getCounter();
		
		String origDirectoryName = IMEnvBase.getEnv( "SR_VAR" ) + "/format";
		File origDir = new File( origDirectoryName );
		
		String backupDirectoryName = workDirName + ".backup" + tempID;
		File backupDir = new File( backupDirectoryName );

		String newDirectoryName = IMEnvBase.getEnv( "SR_VAR" ) + "/format_update_" + tempID;
		String bckDirectoryName = IMEnvBase.getEnv( "SR_VAR" ) + "/format_backup_" + tempID;
		File bckDir = new File( bckDirectoryName );

		try {
			if ( Helper.copyAdvanced( workDirName + "/format", newDirectoryName, true, "r" ) ) {
				if ( Helper.renameTo( origDir, bckDir ) ) {
					File newDir = new File( newDirectoryName );
					if ( newDir.renameTo( origDir ) ) {
						// apply completed
						Vector<String> cmd = new Vector<String>();

						cmd.add( IMEnvBase.getEnv( "DOTCOM_HOME" ) + "/proliferatedir.sh" );
						cmd.add( "-f" );
						cmd.add( origDirectoryName );
						Helper.runCommand( cmd.toArray( new String[ cmd.size() ]) , null );

						// move backup directory to tmp
						Helper.renameTo( bckDir, new File( IMEnvBase.getEnv( "TMP" ) + "/format_backup_" + tempID ) );
						return;
					}
					
					// rename failed - restore original directory
					Helper.renameTo( bckDir, origDir );
				}
			}
		}
		catch ( Throwable th ) {
		}

		File newDir = new File( newDirectoryName );
		if ( newDir.exists() ) {
			Helper.removeDirectoryRecursively( newDirectoryName );
		}
		response.sendError( 500, "An error occurred while applying changes");
		return;
	}

	if ( "cleanup".equals( oper ) ) {
		Helper.removeDirectoryRecursively( workDirName );
		return;
	}
	
	
	response.sendError( 500, "Unrecognized operation: " + oper );
	
	if (true) {
		// For avoiding extra newline(s)
		return;
	}
%>
--%>